/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $Id: wzeichne.c,v 1.18 2004/03/17 01:12:54 fzk Exp $ */

/* Zeichnen des Wuerfelguertels mit Mesa 3-D */

#include <config.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifndef OS_WIN32
#include <sys/time.h>
#endif
/* #include <sys/types.h> */
#include "GL/glut.h"
#include "GL/gl.h"
#include "wuerfel.h"

void WglTestGlError (char *);

char *
getErrorText (GLenum err) {
    switch (err) {
    case GL_INVALID_VALUE:
        return ("GL_INVALID_VALUE");
    case GL_INVALID_ENUM:
        return ("GL_INVALID_ENUM");
    case GL_INVALID_OPERATION:
        return ("GL_INVALID_OPERATION");
    case GL_STACK_OVERFLOW:
        return ("GL_STACK_OVERFLOW");
    case GL_STACK_UNDERFLOW:
        return ("GL_STACK_UNDERFLOW");
    case GL_OUT_OF_MEMORY:
        return ("GL_OUT_OF_MEMORY");
    default:
        return ("unknown error");
    }
}

void
WglTestGlError (char *text) {

    GLenum err;
    char * errText;

    err = glGetError ();
    if (err) {
        errText = getErrorText (err);
        fprintf (stderr, "%s: Error-Code = %d/%s\n", text, err, errText);
    }
}

void
WglDrawString (char *s)
{
    unsigned int i;

    for (i = 0; i < strlen (s); i++) {
        /*      glutBitmapCharacter (GLUT_BITMAP_9_BY_15, s[i]); */
        glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, s[i]);
    }
}

void
zeichnewg (void) {
    unsigned int width;
    unsigned int height;

    rotx = roty = rotz = tranx = trany = tranz = 0.;
    drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
    waittime.tv_sec = 0;
    waittime.tv_usec = 100000;

    halt = FALSE;

    if (options.seite == 0) {
        width = 800 /* DisplayWidth (display, screen) / 2 */ ;
        height = width;
        options.seite = width;
    }
    else {
        width = height = options.seite;
    }

    glutInitWindowSize (options.seite, options.seite);
       /* glutInitWindowPosition (0, 0); */

    winIdMain = glutCreateWindow ("Der umstlpbare Wrfel nach Paul Schatz");

    WglCreateDisplayLists ();

    glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glEnable (GL_DEPTH_TEST);
    glPolygonMode (GL_FRONT_AND_BACK, polygonMode);

    glutKeyboardFunc (WglKey);
    glutSpecialFunc (WglSpecialKey);
    glutDisplayFunc (WglDisplay);
    glutReshapeFunc (WglReshape);
    glutIdleFunc (WglIdle);

    WglCreateMenus ();

    winIdSub =  glutCreateSubWindow (winIdMain, 0, 0, options.seite, options.seite / 7);
    glutDisplayFunc (WglSubDisplay);
    glutReshapeFunc (WglSubReshape);

    glutMainLoop ();
}

#define OP(n,i) owgp->wgp.e[(n)-1].i
#define VON(n) OP((n),x),OP((n),y),OP((n),z)
#define NACH(n) VON(n)

#define OPL(n,i) owgpl->wgp.e[(n)-1].i
#define VONL(n) OPL((n),x),OPL((n),y),OPL((n),z)
#define NACHL(n) VONL(n)

void
WglCreateDisplayLists () {
    int listId;
    WG *owgpl;
    static int e = 1; /* ecke */
    static int z = 1;
    RPUNKT zwi, prevzwi;

    listIdLines = listIdLinesStart = listId = 1; /* listIdLines */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);
            glPushMatrix();
/* 	    glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.); */
            glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);
        glEnable (GL_LINE_SMOOTH);
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(3));
          glVertex3f (VON(1));
          glVertex3f (VON(2));
          glVertex3f (VON(4));
          glVertex3f (VON(1));
        glEnd ();
        if (options.labels) {
            glRasterPos3f (VON(3));
            WglDrawString ("3");
            glRasterPos3f (VON(1));
            WglDrawString ("1");
            glRasterPos3f (VON(2));
            WglDrawString ("2");
            glRasterPos3f (VON(4));
            WglDrawString ("4");
	}
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(7));
          glVertex3f (VON(8));
          glVertex3f (VON(3));
          glVertex3f (VON(4));
          glVertex3f (VON(8));
        glEnd ();
        if (options.labels) {
            glRasterPos3f (VON(7));
            WglDrawString ("7");
            glRasterPos3f (VON(8));
            WglDrawString ("8");
    /*      glRasterPos3f (VON(3)); */
    /*      WglDrawString ("3"); */
    /*      glRasterPos3f (VON(4)); */
    /*      WglDrawString ("4"); */
	}
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(5));
          glVertex3f (VON(6));
          glVertex3f (VON(7));
          glVertex3f (VON(8));
          glVertex3f (VON(6));
        glEnd ();
        if (options.labels) {
            glRasterPos3f (VON(5));
            WglDrawString ("5");
            glRasterPos3f (VON(6));
            WglDrawString ("6");
    /*      glRasterPos3f (VON(7)); */
    /*      WglDrawString ("7"); */
    /*      glRasterPos3f (VON(8)); */
    /*      WglDrawString ("8"); */
	}
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(13));
          glVertex3f (VON(11));
          glVertex3f (VON(12));
          glVertex3f (VON(14));
          glVertex3f (VON(11));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(17));
          glVertex3f (VON(18));
          glVertex3f (VON(13));
          glVertex3f (VON(14));
          glVertex3f (VON(18));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(15));
          glVertex3f (VON(16));
          glVertex3f (VON(17));
          glVertex3f (VON(18));
          glVertex3f (VON(16));
        glEnd ();

        glLineWidth (5.0);
	glBegin (GL_LINES);
/*               glVertex3f (VON(3)); glColor3f (.9,.9,.9); */
/*               glVertex3f (VON(17)); glColor3f (.9,.9,.9); */

              glVertex3f (VON(3)); glColor3f (.9,.9,.9);
              glVertex3f (VON(7)); glColor3f (.9,.9,.9);
              glVertex3f (VON(7)); glColor3f (.9,.9,.9);
              glVertex3f (VON(5)); glColor3f (.9,.9,.9);
        glEnd ();
        glLineWidth (1.0);
            glPopMatrix();

    for (owgpl = wg; owgpl; owgpl = owgpl->nextwgp) {
            glPushMatrix();
/* 	    glRotatef (GWINKEL(owgpl->wgp.w2), 1., 0., 0.); */
            glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.);
          glBegin (GL_LINES);
/* Oloid */
/*               glVertex3f (VONL(3)); glColor3f (VONL(3)); */
/*               glVertex3f (VONL(17)); glColor3f (VONL(17)); */

/* Polkuboid */
              glVertex3f (VONL(3)); glColor3f (VONL(3));
              glVertex3f (VONL(7)); glColor3f (VONL(7));
              glVertex3f (VONL(7)); glColor3f (VONL(7));
              glVertex3f (VONL(5)); glColor3f (VONL(5));

          glEnd ();
            glPopMatrix();
    }

    glEndList ();




        anzpos = listId;   /* anzpos gilt fuer alle Objekt-Listen */
        listId++;
    }

    listIdFill = listIdFillStart = listId; /*  listIdFill */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);
            glPushMatrix();
/* 	    glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.); */
            glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
        /*      glClearColor (0.7, 0.7, 0.0, 0.0); */
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(3)); glColor3f (VON(3));
          glVertex3f (VON(1)); glColor3f (VON(1));
          glVertex3f (VON(2)); glColor3f (VON(2));
          glVertex3f (VON(4)); glColor3f (VON(4));
          glVertex3f (VON(1)); glColor3f (VON(1));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(7)); glColor3f (VON(7));
          glVertex3f (VON(8)); glColor3f (VON(8));
          glVertex3f (VON(3)); glColor3f (VON(3));
          glVertex3f (VON(4)); glColor3f (VON(4));
          glVertex3f (VON(8)); glColor3f (VON(8));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(5)); glColor3f (VON(5));
          glVertex3f (VON(6)); glColor3f (VON(6));
          glVertex3f (VON(7)); glColor3f (VON(7));
          glVertex3f (VON(8)); glColor3f (VON(8));
          glVertex3f (VON(6)); glColor3f (VON(6));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(13)); glColor3f (VON(3));
          glVertex3f (VON(11)); glColor3f (VON(1));
          glVertex3f (VON(12)); glColor3f (VON(2));
          glVertex3f (VON(14)); glColor3f (VON(4));
          glVertex3f (VON(11)); glColor3f (VON(1));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(17)); glColor3f (VON(7));
          glVertex3f (VON(18)); glColor3f (VON(8));
          glVertex3f (VON(13)); glColor3f (VON(3));
          glVertex3f (VON(14)); glColor3f (VON(4));
          glVertex3f (VON(18)); glColor3f (VON(8));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(15)); glColor3f (VON(5));
          glVertex3f (VON(16)); glColor3f (VON(6));
          glVertex3f (VON(17)); glColor3f (VON(7));
          glVertex3f (VON(18)); glColor3f (VON(8));
          glVertex3f (VON(16)); glColor3f (VON(6));
        glEnd ();

        glLineWidth (5.0);
	glBegin (GL_LINES);
/*               glVertex3f (VON(3)); glColor3f (.9,.9,.9); */
/*               glVertex3f (VON(17)); glColor3f (.9,.9,.9); */


              glVertex3f (VON(3)); glColor3f (.9,.9,.9);
              glVertex3f (VON(7)); glColor3f (.9,.9,.9);
              glVertex3f (VON(7)); glColor3f (.9,.9,.9);
              glVertex3f (VON(5)); glColor3f (.9,.9,.9);
        glEnd ();
        glLineWidth (1.0);

            glPopMatrix();

    for (owgpl = wg; owgpl; owgpl = owgpl->nextwgp) {
            glPushMatrix();
/* 	    glRotatef (GWINKEL(owgpl->wgp.w2), 1., 0., 0.); */
            glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.);
          glBegin (GL_LINES);
/* Oloid */
/*               glVertex3f (VONL(3)); glColor3f (VONL(3)); */
/*               glVertex3f (VONL(17)); glColor3f (VONL(17)); */


/* Polkuboid */
              glVertex3f (VONL(3)); glColor3f (VONL(3));
              glVertex3f (VONL(7)); glColor3f (VONL(7));
              glVertex3f (VONL(7)); glColor3f (VONL(7));
              glVertex3f (VONL(5)); glColor3f (VONL(5));
          glEnd ();
            glPopMatrix();
    }

        glEndList ();
        listId++;
    }

    listIdVirt = listIdVirtStart = listId; /* listIdvirt */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);
        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);
        glBegin (GL_LINES);
          glVertex3f (VON(4));  glVertex3f (NACH(9));
          glVertex3f (VON(6));  glVertex3f (NACH(9));
          glVertex3f (VON(14)); glVertex3f (NACH(9));

          glVertex3f (VON(2));  glVertex3f (NACH(10));
          glVertex3f (VON(8));  glVertex3f (NACH(10));
          glVertex3f (VON(18)); glVertex3f (NACH(10));
        glEnd ();
        glEndList ();
        listId++;
    }

    listIdAch = listIdAchStart = listId; /* listIdAch */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);
        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);
        glBegin (GL_LINES);
          glVertex3f (VON(1)); glVertex3f (NACH(19));
          glVertex3f (VON(1)); glVertex3f (NACH(20));
          glVertex3f (VON(1)); glVertex3f (NACH(21));
        glEnd ();
        glRasterPos3f (VON(19));
        WglDrawString ("X");
        glRasterPos3f (VON(20));
        WglDrawString ("Y");
        glRasterPos3f (VON(21));
        WglDrawString ("Z");
        glEndList ();
        listId++;
    }


#define OPP(n,i) prevwgp->wgp.e[(n)-1].i
#define PREVVON(n) OPP((n),x),OPP((n),y),OPP((n),z)

#define ZVON zwi.x,zwi.y,zwi.z
#define ZPREVVON prevzwi.x,prevzwi.y,prevzwi.z

    listIdTime1 = listIdTime1Start = listId; /*  listIdTime1 */
    glNewList (listId, GL_COMPILE);

    for (owgp = wg; owgp /* && (owgp->wgp.w > M_PI) */; owgp = owgp->nextwgp) {
        WG *prevwgp;
	float w, w2;

	owgpl = owgp;
        prevwgp = (owgp == wg) ? last : owgp->prevwgp;

#define QUAD(a,b) \
        glVertex3f (VON(a));  glColor3f (VON(a)); \
	glVertex3f (VON(b));  glColor3f (VON(b)); \
	glVertex3f (PREVVON(b)); glColor3f (PREVVON(b)); \
	glVertex3f (PREVVON(a)); glColor3f (PREVVON(a));

#define WL       (owgpl->wgp.w)
#define WL2      (owgpl->wgp.w2)
#define TRANX(l) \
        zwi.x = OPL(l,x); \
        zwi.y = OPL(l,y) *  cos(M_PI/2.-WL) + OPL(l,z) *  sin(M_PI/2.-WL); \
        zwi.z = OPL(l,y) * -sin(M_PI/2.-WL) + OPL(l,z) *  cos(M_PI/2.-WL);
#define TRANY(l) \
        zwi.x = OPL(l,x) *  cos(M_PI/2.-WL) + OPL(l,z) * -sin(M_PI/2.-WL); \
        zwi.y = OPL(l,y); \
        zwi.z = OPL(l,x) *  sin(M_PI/2.-WL) + OPL(l,z) *  cos(M_PI/2.-WL);
#define TRANZ(l) \
        zwi.x = OPL(l,x) *  cos(M_PI/2.-WL) + OPL(l,y) * -sin(M_PI/2.-WL); \
        zwi.y = OPL(l,y) * -sin(M_PI/2.-WL) + OPL(l,y) *  cos(M_PI/2.-WL); \
        zwi.z = OPL(l,z);

#define PWL      (prevwgp->wgp.w)
#define PREVTRANX(l) \
        prevzwi.x = OPP(l,x); \
        prevzwi.y = OPP(l,y) *  cos(M_PI/2.-PWL) + OPP(l,z) *  sin(M_PI/2.-PWL); \
        prevzwi.z = OPP(l,y) * -sin(M_PI/2.-PWL) + OPP(l,z) *  cos(M_PI/2.-PWL);
#define PREVTRANY(l) \
        prevzwi.x = OPP(l,x) *  cos(M_PI/2.-PWL) + OPP(l,z) * -sin(M_PI/2.-PWL); \
        prevzwi.y = OPP(l,y); \
        prevzwi.z = OPP(l,x) *  sin(M_PI/2.-PWL) + OPP(l,z) *  cos(M_PI/2.-PWL);
#define PREVTRANZ(l) \
        prevzwi.x = OPP(l,x) *  cos(M_PI/2.-PWL) + OPP(l,y) * -sin(M_PI/2.-PWL); \
        prevzwi.y = OPP(l,y) * -sin(M_PI/2.-PWL) + OPP(l,y) *  cos(M_PI/2.-PWL); \
        prevzwi.z = OPP(l,z);

	/* Polkuboid */
/*           glBegin (GL_LINES); */
/* 	    TRANY(3) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(3) */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */

/* 	    TRANY(3) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */

/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(7); */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */

/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    TRANY(5) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */

/* 	    TRANY(5) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(5); */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */
/*           glEnd (); */

/* Polkuboid */
/*             glMatrixMode (GL_MODELVIEW); */
/*             glPushMatrix(); */
/*             glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.); */
/*           glBegin (GL_LINES); */
/*               glVertex3f (VON(3)); glColor3f (VON(3)); */
/*               glVertex3f (VON(7)); glColor3f (VON(7)); */
/*               glVertex3f (VON(7)); glColor3f (VON(7)); */
/*               glVertex3f (VON(5)); glColor3f (VON(5)); */
/*           glEnd (); */
/*             glPopMatrix(); */
/*             glMatrixMode (GL_PROJECTION); */

/* Oloid */
/*             glMatrixMode (GL_MODELVIEW); */
            glPushMatrix();
	    glRotatef (GWINKEL(owgpl->wgp.w2), 1., 0., 0.);
            glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.);
          glBegin (GL_LINES);
              glVertex3f (VON(3)); glColor3f (VON(3));
              glVertex3f (VON(17)); glColor3f (VON(17));
          glEnd ();
            glPopMatrix();
/*             glMatrixMode (GL_PROJECTION); */


    }
    glEndList ();
    listId++;

    owgp = wg;
}

void
WglDisplay (void) {

    glutSetWindow (winIdMain);
    glClearColor (0.7, 0.7, 0.0, 0.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glLoadIdentity ();

    /*    glTranslatef (tranx + dtranx, trany + dtrany, tranz + dtranz - 5.0); */
    glTranslatef (tranx + dtranx, trany + dtrany, tranz + dtranz - 5.);

    glRotatef (rotx + drotx, 1.0, 0.0, 0.0);
    glRotatef (roty + droty, 0.0, 1.0, 0.0);
    glRotatef (rotz + drotz, 0.0, 0.0, 1.0);

    if (options.mode == 3) {
        glRotatef (GWINKEL(owgp->wgp.w2), 1.0, 0.0, 0.0);
    }
    if (options.mode == 2 || options.mode == 3) {
        glRotatef (GWINKEL(owgp->wgp.w), 0.0, 1.0, 0.0);
    }

    if (polygonMode == GL_FILL) {
        glCallList (listIdFill);
/*         glCallList (listIdTime1); */
    }
    else {
        glCallList (listIdLines);
    }

    if (options.ei) {
        glCallList (listIdVirt);
    }

    if (options.ach) {
        glCallList (listIdAch);
    }
    
/*     glBegin (GL_LINES); */
/*     for (i = 0; i < anzkanten; i++) { */
/*      glVertex3f (VON(kante[i].von)); */
/*      glVertex3f (NACH(kante[i].nach)); */
/*     } */
/*     glEnd (); */

    glutSwapBuffers ();
}

void
WglReshape (int w, int  h) {

    glutSetWindow (winIdMain);
    glViewport (0, 0, w, h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

    if (options.perspektive) {
        /* glFrustum (-2.5, 2.5, -2.5, 2.5, 1.0, 10.0); */
        /* vert. angle, aspect ratio, near, far clipp */
        gluPerspective (60, 1., 1., 200.);
    }
    else {
        /* gute Gre fr Modus 1, um animated gif zu erstellen */
        /* glOrtho (-0.9, 2.5, -1.7, 1.7, -3.0, 7.0); */
        /* gute Gre fr Modus 2 und 3, um animated gif zu erstellen */
        glOrtho (-2.5, 2.5, -2.5, 2.5, -10.0, 10.0);
    }

    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();

    /* Invoke subwindow reshape */
    glutSetWindow (winIdSub);
    glutReshapeWindow (w, h / 7);
    glutPositionWindow (0, 0);
}

void
WglIdle (void) {
    struct timeval tv;

#ifdef OS_WIN32
    /*
    ** Idle-Loop, wie funktioniert das vernnftig unter Windows ohne select?
    */
    int i, j;
    char buf[2];

    memcpy (&tv, &waittime, sizeof (struct timeval));
    if (tv.tv_usec < 0) {
        tv.tv_usec = - tv.tv_usec;
    }
    j = 1;
    for (i = 1; i < tv.tv_usec; i++) {
        buf[i/i] = buf[j/j];
    }
#else
    memcpy (&tv, &waittime, sizeof (struct timeval));
    select (0, NULL, NULL, NULL, &waittime);
    memcpy (&waittime, &tv, sizeof (struct timeval));
#endif

    if (! halt) {
        WglNextPos ();
        WglPostRedisplay ();
    }
}

void
WglNextPos (void) {
    owgp = owgp->nextwgp ? owgp->nextwgp : wg;
    if (owgp == wg) {
        listIdLines = listIdLinesStart;
        listIdFill = listIdFillStart;
        listIdVirt = listIdVirtStart;
        listIdAch = listIdAchStart;
        listIdTime1 = listIdTime1Start;
    }
    else {
        listIdLines++;
        listIdFill++;
        listIdVirt++;
        listIdAch++;
/*         listIdTime1++; */
    }
    if (options.tork) {
        torkle ();
    }
}

void
WglPrevPos (void) {
    owgp = owgp->prevwgp ? owgp->prevwgp : last;
    if (owgp == wg) {
        listIdLines = listIdLinesStart + anzpos;
        listIdFill = listIdFillStart + anzpos;
        listIdVirt = listIdVirtStart + anzpos;
        listIdAch = listIdAchStart + anzpos;
/*         listIdTime1 = listIdTime1Start + anzpos; */
    }
    listIdLines--;
    listIdFill--;
    listIdVirt--;
    listIdAch--;
/*     listIdTime1--; */
    if (options.tork) {
        torkle ();
    }
}

void
WglSubDisplay (void) {

    char label[128];

    /* Clear subwindow */
    glutSetWindow (winIdSub);
    glClearColor (0.25, 0.25, 0.25, 0.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    /* Draw border */
    glColor3f (0.0, 1.0, 0.0);
    glBegin (GL_LINE_LOOP);
      glVertex2f (0., 0.);
      glVertex2f (0., 0.99);
      glVertex2f (0.999, 0.99);
      glVertex2f (0.999, 0.);
    glEnd ();

    /* Write State Variables */
    glColor3f (1.0, 1.0, 1.0);
    sprintf (label, "Modus = %s ", modus_txt[options.mode]);
    glRasterPos2f (0.02F, 0.82F);
    WglDrawString (label);

    sprintf (label, "Darstellung = %s ", darstellung_txt[options.lines]);
    glRasterPos2f (0.02F, 0.62F);
    WglDrawString (label);

    sprintf (label, "Schweben = %s ", options.tork ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.42F);
    WglDrawString (label);

    sprintf (label, "Achsen = %s ", options.ach ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.22F);
    WglDrawString (label);

    sprintf (label, "virtuelle Wuerfelpunkte = %s ", options.ei ? "ein" : "aus");
    glRasterPos2f (0.02F, 0.04F);
    WglDrawString (label);

    /* Write Banner and info */

    sprintf (label, "Winkel = %6.2f ", 360. - GWINKEL (owgp->wgp.w));
    glRasterPos2f (0.4F, 0.82F);
    WglDrawString (label);

    sprintf (label, "Verschiebung x/y/z = %6.2f/%6.2f/%6.2f", tranx+dtranx, trany+dtrany, tranz+dtranz);
    glRasterPos2f (0.4F, 0.62F);
    WglDrawString (label);

    sprintf (label, "Rotation x/y/z = %6.2f/%6.2f/%6.2f", rotx, roty, rotz);
    glRasterPos2f (0.4F, 0.42F);
    WglDrawString (label);

    sprintf (label, "(c) 1999 Franz Zahaurek, http://www.fzk.at");
    glRasterPos2f (0.4F, 0.04F);
    WglDrawString (label);

/*     glColor3f (1.0, 0.0, 1.0); */
/*     sprintf (label, " This is a subwindow "); */
/*     glRasterPos2f (0.40F, 0.70F); */
/*     WglDrawStringBig (label); */

/*     sprintf (label, " It has its own OpenGL context "); */
/*     glRasterPos2f (0.33F, 0.35F); */
/*     WglDrawStringBig (label); */

    if (options.info) {
      glutShowWindow();
    }
    else {
      glutHideWindow();
    }
    glutSwapBuffers ();
}

/* Callback function for reshaping the subwindow */
void
WglSubReshape (int w, int h)
{
    glViewport (0, 0, w, h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    /* gluOrtho2D (0.0, 1.0, 0.0, 1.0); */
    glOrtho (0.0, 1.0, 0.0, 1.0, -1., 1.);
}

void
WglPostRedisplay (void) {
    glutPostWindowRedisplay (winIdMain);
    glutPostWindowRedisplay (winIdSub);
}

/* Schweben: Verschiebung und Rotation zufllig steuern */
#define DELTA_T 0.01
#define DELTA_R 1.0
#define LIM_UPP_T 0.8
#define LIM_LOW_T -0.8
#ifdef OS_WIN32
#define ZUF               ((float)ranf (0.))
#else
#define ZUF               ((float)random () / (float)RAND_MAX)
#endif

void
torkle (void) {
    static BOOLEAN firsttime = TRUE;
    static float ddtranx, ddtrany, ddtranz, ddrotx, ddroty, ddrotz;
    static BOOLEAN xup = TRUE;
    static BOOLEAN yup = TRUE;
    static BOOLEAN zup = TRUE;

    if (firsttime || !owgp->nextwgp) {
        firsttime = FALSE;
        ddtranx = ZUF * DELTA_T;
        ddtrany = ZUF * DELTA_T;
        ddtranz = ZUF * DELTA_T;
        ddrotx = ZUF * DELTA_R;
        ddroty = ZUF * DELTA_R;
        ddrotz = ZUF * DELTA_R;
    }

    if (dtranx < LIM_LOW_T || LIM_UPP_T < dtranx) { xup = !xup;}
    if (dtrany < LIM_LOW_T || LIM_UPP_T < dtrany) { yup = !yup;}
    if (dtranz < LIM_LOW_T || LIM_UPP_T < dtranz) { zup = !zup;}

    dtranx += ddtranx * (xup ? 1. : -1.);
    dtrany += ddtrany * (yup ? 1. : -1.);
    dtranz += ddtranz * (zup ? 1. : -1.);
    drotx += ddrotx;
    drotx = drotx > 360. ? drotx - 360. : drotx;
    droty += ddroty;
    droty = droty > 360. ? droty - 360. : droty;
    drotz += ddrotz;
    drotz = drotz > 360. ? drotz - 360. : drotz;
}

#ifdef OS_WIN32
/* Die Funktion ranf() entstammt dem Source-Code von gnuplot-3.7 */
/***********************************************************************
     double ranf(double init)
                RANDom number generator as a Function
     Returns a random floating point number from a uniform distribution
     over 0 - 1 (endpoints of this interval are not returned) using a
     large integer generator.
     This is a transcription from Pascal to Fortran of routine
     Uniform_01 from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)

               GeNerate LarGe Integer
     Returns a random integer following a uniform distribution over
     (1, 2147483562) using the generator.
     This is a transcription from Pascal to Fortran of routine
     Random from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)
***********************************************************************/
#define Xm1  2147483563L
#define Xm2  2147483399L
#define Xa1  40014L
#define Xa2  40692L

double ranf(init)
double init;
{

    long k, z;
    static int firsttime = 1;
    static long s1, s2;

    /* (Re)-Initialize seeds if necessary */
    if (init < 0.0 || firsttime == 1) {
        firsttime = 0;
        s1 = 1234567890L;
        s2 = 1234567890L;
    }
    /* Generate pseudo random integers */
    k = s1 / 53668L;
    s1 = Xa1 * (s1 - k * 53668L) - k * 12211;
    if (s1 < 0)
        s1 += Xm1;
    k = s2 / 52774L;
    s2 = Xa2 * (s2 - k * 52774L) - k * 3791;
    if (s2 < 0)
        s2 += Xm2;
    z = s1 - s2;
    if (z < 1)
        z += (Xm1 - 1);

    /*
     * 4.656613057E-10 is 1/Xm1.  Xm1 is set at the top of this file and is
     * currently 2147483563. If Xm1 changes, change this also.
     */
    return (double) 4.656613057E-10 *z;
}
#endif
